package cn.com.infosec.jce.provider;

import cn.com.infosec.crypto.Digest;
import cn.com.infosec.crypto.PBEParametersGenerator;
import cn.com.infosec.crypto.digests.SHA1Digest;
import cn.com.infosec.crypto.generators.PKCS12ParametersGenerator;
import cn.com.infosec.crypto.io.DigestInputStream;
import cn.com.infosec.crypto.io.DigestOutputStream;
import cn.com.infosec.crypto.io.MacInputStream;
import cn.com.infosec.crypto.io.MacOutputStream;
import cn.com.infosec.crypto.macs.HMac;
import cn.com.infosec.jce.interfaces.BCKeyStore;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Key;
import java.security.KeyFactory;
import java.security.KeyStoreException;
import java.security.KeyStoreSpi;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.UnrecoverableKeyException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.spec.KeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class JDKKeyStore extends KeyStoreSpi implements BCKeyStore {
   private static final int STORE_VERSION = 1;
   private static final int STORE_SALT_SIZE = 20;
   private static final String STORE_CIPHER = "PBEWithSHAAndTwofish-CBC";
   private static final int KEY_SALT_SIZE = 20;
   private static final int MIN_ITERATIONS = 1024;
   private static final String KEY_CIPHER = "PBEWithSHAAnd3-KeyTripleDES-CBC";
   static final int NULL = 0;
   static final int CERTIFICATE = 1;
   static final int KEY = 2;
   static final int SECRET = 3;
   static final int SEALED = 4;
   static final int KEY_PRIVATE = 0;
   static final int KEY_PUBLIC = 1;
   static final int KEY_SECRET = 2;
   protected Hashtable table;
   protected SecureRandom random;

   public JDKKeyStore() {
      JDKKeyStore var10000 = this;
      JDKKeyStore var10001 = this;
      super();
      Hashtable var1;
      var1 = new Hashtable.<init>();
      var10001.table = var1;
      SecureRandom var2;
      var2 = new SecureRandom.<init>();
      var10000.random = var2;
   }

   private void encodeCertificate(Certificate param1, DataOutputStream param2) {
      // $FF: Couldn't be decompiled
   }

   private Certificate decodeCertificate(DataInputStream dIn) {
      String var10000 = dIn.readUTF();
      byte[] var4;
      dIn.readFully(var4 = new byte[dIn.readInt()]);

      try {
         return CertificateFactory.getInstance(var10000, "INFOSEC").generateCertificate(new ByteArrayInputStream(var4));
      } catch (NoSuchProviderException var2) {
         throw new IOException(var2.toString());
      } catch (CertificateException var3) {
         throw new IOException(var3.toString());
      }
   }

   private void encodeKey(Key key, DataOutputStream dOut) {
      byte[] var3 = key.getEncoded();
      if (key instanceof PrivateKey) {
         dOut.write(0);
      } else if (key instanceof PublicKey) {
         dOut.write(1);
      } else {
         dOut.write(2);
      }

      dOut.writeUTF(key.getFormat());
      dOut.writeUTF(key.getAlgorithm());
      dOut.writeInt(var3.length);
      dOut.write(var3);
   }

   private Key decodeKey(DataInputStream dIn) {
      int var9 = dIn.read();
      String var2;
      String var10000 = var2 = dIn.readUTF();
      DataInputStream var10001 = dIn;
      DataInputStream var10002 = dIn;
      String dIn1 = dIn.readUTF();
      byte[] var3;
      var10001.readFully(var3 = new byte[var10002.readInt()]);
      Object var12;
      if (!var10000.equals("PKCS#8") && !var2.equals("PKCS8")) {
         if (!var2.equals("X.509") && !var2.equals("X509")) {
            if (var2.equals("RAW")) {
               return new SecretKeySpec(var3, dIn1);
            }

            throw new IOException("Key format " + var2 + " not recognised!");
         }

         var12 = new X509EncodedKeySpec.<init>(var3);
      } else {
         var12 = new PKCS8EncodedKeySpec.<init>(var3);
      }

      Exception var13;
      boolean var15;
      if (var9 != 0) {
         if (var9 != 1) {
            if (var9 == 2) {
               try {
                  return SecretKeyFactory.getInstance(dIn1, "INFOSEC").generateSecret((KeySpec)var12);
               } catch (Exception var4) {
                  var13 = var4;
                  var15 = false;
               }
            } else {
               label66: {
                  IOException var14;
                  IOException var16;
                  StringBuilder var17;
                  try {
                     var14 = new IOException;
                     var16 = var14;
                     var17 = new StringBuilder;
                  } catch (Exception var6) {
                     var13 = var6;
                     var15 = false;
                     break label66;
                  }

                  StringBuilder var10003 = var17;

                  try {
                     var10003.<init>("Key type ");
                     var16.<init>(var17.append(var9).append(" not recognised!").toString());
                     throw var14;
                  } catch (Exception var5) {
                     var13 = var5;
                     var15 = false;
                  }
               }
            }
         } else {
            try {
               return KeyFactory.getInstance(dIn1, "INFOSEC").generatePublic((KeySpec)var12);
            } catch (Exception var7) {
               var13 = var7;
               var15 = false;
            }
         }
      } else {
         try {
            return KeyFactory.getInstance(dIn1, "INFOSEC").generatePrivate((KeySpec)var12);
         } catch (Exception var8) {
            var13 = var8;
            var15 = false;
         }
      }

      Exception var10 = var13;
      throw new IOException("Exception creating key: " + var10.toString());
   }

   protected Cipher makePBECipher(String algorithm, int mode, char[] password, byte[] salt, int iterationCount) {
      Exception var10000;
      label37: {
         String var14;
         String var15;
         boolean var10001;
         PBEKeySpec var10002;
         try {
            var14 = algorithm;
            var15 = algorithm;
            var10002 = new PBEKeySpec;
         } catch (Exception var9) {
            var10000 = var9;
            var10001 = false;
            break label37;
         }

         PBEKeySpec var10 = var10002;

         SecretKeyFactory var16;
         try {
            var10002.<init>(password);
            var16 = SecretKeyFactory.getInstance(var15, "INFOSEC");
         } catch (Exception var8) {
            var10000 = var8;
            var10001 = false;
            break label37;
         }

         SecretKeyFactory algorithm1 = var16;

         PBEParameterSpec var18;
         try {
            var18 = new PBEParameterSpec;
         } catch (Exception var7) {
            var10000 = var7;
            var10001 = false;
            break label37;
         }

         PBEParameterSpec password1 = var18;

         try {
            var18.<init>(salt, iterationCount);
            Cipher var17 = Cipher.getInstance(var14, "INFOSEC");
            var17.init(mode, algorithm1.generateSecret(var10), password1);
            return var17;
         } catch (Exception var6) {
            var10000 = var6;
            var10001 = false;
         }
      }

      Exception var11 = var10000;
      throw new IOException("Error initialising store of key store: " + var11);
   }

   public void setRandom(SecureRandom rand) {
      this.random = rand;
   }

   public Enumeration engineAliases() {
      return this.table.keys();
   }

   public boolean engineContainsAlias(String alias) {
      return this.table.get(alias) != null;
   }

   public void engineDeleteEntry(String alias) {
      if (this.table.get(alias) != null) {
         this.table.remove(alias);
      } else {
         throw new KeyStoreException("no such entry as " + alias);
      }
   }

   public Certificate engineGetCertificate(String alias) {
      StoreEntry var2;
      if ((var2 = (StoreEntry)this.table.get(alias)) != null) {
         if (var2.getType() == 1) {
            return (Certificate)var2.getObject();
         }

         Certificate[] var3;
         if ((var3 = var2.getCertificateChain()) != null) {
            return var3[0];
         }
      }

      return null;
   }

   public String engineGetCertificateAlias(Certificate cert) {
      Enumeration var4 = this.table.elements();

      while(var4.hasMoreElements()) {
         StoreEntry var2;
         if ((var2 = (StoreEntry)var4.nextElement()).getObject() instanceof Certificate) {
            if (((Certificate)var2.getObject()).equals(cert)) {
               return var2.getAlias();
            }
         } else {
            Certificate[] var3;
            if ((var3 = var2.getCertificateChain()) != null && var3[0].equals(cert)) {
               return var2.getAlias();
            }
         }
      }

      return null;
   }

   public Certificate[] engineGetCertificateChain(String alias) {
      StoreEntry var2;
      return (var2 = (StoreEntry)this.table.get(alias)) != null ? var2.getCertificateChain() : null;
   }

   public Date engineGetCreationDate(String alias) {
      StoreEntry var2;
      return (var2 = (StoreEntry)this.table.get(alias)) != null ? var2.getDate() : null;
   }

   public Key engineGetKey(String alias, char[] password) {
      StoreEntry var3;
      return (var3 = (StoreEntry)this.table.get(alias)) != null && var3.getType() != 1 ? (Key)var3.getObject(password) : null;
   }

   public boolean engineIsCertificateEntry(String alias) {
      StoreEntry var2;
      return (var2 = (StoreEntry)this.table.get(alias)) != null && var2.getType() == 1;
   }

   public boolean engineIsKeyEntry(String alias) {
      StoreEntry var2;
      return (var2 = (StoreEntry)this.table.get(alias)) != null && var2.getType() != 1;
   }

   public void engineSetCertificateEntry(String alias, Certificate cert) {
      StoreEntry var3;
      if ((var3 = (StoreEntry)this.table.get(alias)) != null && var3.getType() != 1) {
         throw new KeyStoreException("key store already has a key entry with alias " + alias);
      } else {
         Hashtable var10000 = this.table;
         var3 = new StoreEntry.<init>(alias, cert);
         var10000.put(alias, var3);
      }
   }

   public void engineSetKeyEntry(String alias, byte[] key, Certificate[] chain) {
      Hashtable var10000 = this.table;
      StoreEntry var4;
      var4 = new StoreEntry.<init>(alias, key, chain);
      var10000.put(alias, var4);
   }

   public void engineSetKeyEntry(String alias, Key key, char[] password, Certificate[] chain) {
      if (key instanceof PrivateKey && chain == null) {
         throw new KeyStoreException("no certificate chain for private key");
      } else {
         try {
            this.table.put(alias, new StoreEntry(alias, key, password, chain));
         } catch (Exception var5) {
            throw new KeyStoreException(var5.toString());
         }

      }
   }

   public int engineSize() {
      return this.table.size();
   }

   protected boolean isSameAs(byte[] one, byte[] two) {
      if (one.length != two.length) {
         return false;
      } else {
         for(int var3 = 0; var3 != one.length; ++var3) {
            if (one[var3] != two[var3]) {
               return false;
            }
         }

         return true;
      }
   }

   protected void loadStore(InputStream in) {
      DataInputStream var2;
      DataInputStream var10000 = var2 = new DataInputStream;
      var10000.<init>(in);

      for(int in1 = var10000.read(); in1 > 0; in1 = var2.read()) {
         String var3 = var2.readUTF();
         Date var4;
         var4 = new Date.<init>(var2.readLong());
         int var5;
         int var14 = var5 = var2.readInt();
         StoreEntry var6 = null;
         Certificate[] var7;
         if (var14 != 0) {
            var7 = new Certificate[var5];

            for(int var13 = 0; var13 != var5; ++var13) {
               var7[var13] = this.decodeCertificate(var2);
            }
         } else {
            var7 = var6;
         }

         StoreEntry var12;
         Hashtable var15;
         switch (in1) {
            case 1:
               Certificate in3 = this.decodeCertificate(var2);
               var15 = this.table;
               var12 = new StoreEntry.<init>(var3, var4, 1, in3);
               var15.put(var3, var12);
               break;
            case 2:
               Key in2 = this.decodeKey(var2);
               var15 = this.table;
               var12 = new StoreEntry.<init>(var3, var4, 2, in2, var7);
               var15.put(var3, var12);
               break;
            case 3:
            case 4:
               byte[] var11;
               var2.readFully(var11 = new byte[var2.readInt()]);
               var15 = this.table;
               var6 = new StoreEntry.<init>(var3, var4, in1, var11, var7);
               var15.put(var3, var6);
               break;
            default:
               throw new RuntimeException("Unknown object type in store.");
         }
      }

   }

   protected void saveStore(OutputStream out) {
      Enumeration var2 = this.table.elements();
      DataOutputStream var3;
      var3 = new DataOutputStream.<init>(out);

      while(var2.hasMoreElements()) {
         StoreEntry out1;
         StoreEntry var10000 = out1 = (StoreEntry)var2.nextElement();
         var3.write(out1.getType());
         var3.writeUTF(out1.getAlias());
         var3.writeLong(out1.getDate().getTime());
         Certificate[] var4;
         if ((var4 = var10000.getCertificateChain()) == null) {
            var3.writeInt(0);
         } else {
            var3.writeInt(var4.length);

            for(int var5 = 0; var5 != var4.length; ++var5) {
               this.encodeCertificate(var4[var5], var3);
            }
         }

         switch (out1.getType()) {
            case 1:
               this.encodeCertificate((Certificate)out1.getObject(), var3);
               break;
            case 2:
               this.encodeKey((Key)out1.getObject(), var3);
               break;
            case 3:
            case 4:
               byte[] out2;
               var3.writeInt((out2 = (byte[])out1.getObject()).length);
               var3.write(out2);
               break;
            default:
               throw new RuntimeException("Unknown object type in store.");
         }
      }

      var3.write(0);
   }

   public void engineLoad(InputStream stream, char[] password) {
      this.table.clear();
      if (stream != null) {
         DataInputStream var3;
         DataInputStream var10000 = var3 = new DataInputStream;
         var10000.<init>(stream);
         int stream1;
         if ((stream1 = var10000.readInt()) != 1 && stream1 != 0) {
            throw new IOException("Wrong version of key store.");
         } else {
            byte[] stream2;
            var3.readFully(stream2 = new byte[var3.readInt()]);
            int var4 = var3.readInt();
            HMac var5;
            HMac var14 = var5 = new HMac;
            var14.<init>(new SHA1Digest());
            MacInputStream var6;
            var6 = new MacInputStream.<init>(var3, var5);
            PKCS12ParametersGenerator var7;
            PKCS12ParametersGenerator var10001 = var7 = new PKCS12ParametersGenerator;
            var7.<init>(new SHA1Digest());
            byte[] var13;
            var7.init(var13 = PBEParametersGenerator.PKCS12PasswordToBytes(password), stream2, var4);
            var14.init(var10001.generateDerivedMacParameters(var5.getMacSize()));

            for(stream1 = 0; stream1 != var13.length; ++stream1) {
               var13[stream1] = 0;
            }

            this.loadStore(var6);
            byte[] var12 = new byte[var5.getMacSize()];
            int var8 = var5.getMacSize();
            byte[] var9 = new byte[var8];
            var5.doFinal(var12, 0);

            for(stream1 = 0; stream1 != var8; ++stream1) {
               var9[stream1] = (byte)var3.read();
            }

            if (password != null && password.length != 0 && !this.isSameAs(var12, var9)) {
               this.table.clear();
               throw new IOException("KeyStore integrity check failed.");
            }
         }
      }
   }

   public void engineStore(OutputStream stream, char[] password) {
      DataOutputStream var3;
      DataOutputStream var10000 = var3 = new DataOutputStream;
      var3.<init>(stream);
      byte[] stream1 = new byte[20];
      int var4 = (this.random.nextInt() & 1023) + 1024;
      this.random.nextBytes(stream1);
      var10000.writeInt(1);
      var10000.writeInt(20);
      var10000.write(stream1);
      var10000.writeInt(var4);
      HMac var5;
      HMac var12 = var5 = new HMac;
      var12.<init>(new SHA1Digest());
      MacOutputStream var6;
      var6 = new MacOutputStream.<init>(var3, var5);
      PKCS12ParametersGenerator var7;
      PKCS12ParametersGenerator var10001 = var7 = new PKCS12ParametersGenerator;
      var7.<init>(new SHA1Digest());
      byte[] password1;
      var7.init(password1 = PBEParametersGenerator.PKCS12PasswordToBytes(password), stream1, var4);
      var12.init(var10001.generateDerivedMacParameters(var5.getMacSize()));

      for(int stream2 = 0; stream2 != password1.length; ++stream2) {
         password1[stream2] = 0;
      }

      this.saveStore(var6);
      byte[] var8;
      var5.doFinal(var8 = new byte[var5.getMacSize()], 0);
      var3.write(var8);
      var3.close();
   }

   public static class InfosecStore extends JDKKeyStore {
      public void engineLoad(InputStream stream, char[] password) {
         super.table.clear();
         if (stream != null) {
            DataInputStream var3;
            DataInputStream var10000 = var3 = new DataInputStream;
            var10000.<init>(stream);
            int stream1;
            if ((stream1 = var10000.readInt()) != 1 && stream1 != 0) {
               throw new IOException("Wrong version of key store.");
            } else {
               int var12 = var3.readInt();
               byte[] var4 = new byte[var12];
               if (var12 != 20) {
                  throw new IOException("Key store corrupted.");
               } else {
                  var3.readFully(var4);
                  int var5;
                  if ((var5 = var3.readInt()) >= 0 && var5 <= 4096) {
                     Cipher stream2;
                     if (stream1 == 0) {
                        stream2 = this.makePBECipher("OldPBEWithSHAAndTwofish-CBC", 2, password, var4, var5);
                     } else {
                        stream2 = this.makePBECipher("PBEWithSHAAndTwofish-CBC", 2, password, var4, var5);
                     }

                     CipherInputStream password1;
                     password1 = new CipherInputStream.<init>(var3, stream2);
                     DigestInputStream stream3;
                     DigestInputStream var13 = stream3 = new DigestInputStream;
                     SHA1Digest var10;
                     var10 = new SHA1Digest.<init>();
                     stream3.<init>(password1, var10);
                     this.loadStore(stream3);
                     Digest var14 = var13.getDigest();
                     int var10001 = stream1 = var14.getDigestSize();
                     byte[] var11 = new byte[var10001];
                     var4 = new byte[var10001];
                     var14.doFinal(var11, 0);

                     for(var5 = 0; var5 != stream1; ++var5) {
                        var4[var5] = (byte)password1.read();
                     }

                     if (!this.isSameAs(var11, var4)) {
                        super.table.clear();
                        throw new IOException("KeyStore integrity check failed.");
                     }
                  } else {
                     throw new IOException("Key store corrupted.");
                  }
               }
            }
         }
      }

      public void engineStore(OutputStream stream, char[] password) {
         DataOutputStream var3;
         DataOutputStream var10001 = var3 = new DataOutputStream;
         var3.<init>(stream);
         byte[] stream1 = new byte[20];
         int var4 = (super.random.nextInt() & 1023) + 1024;
         super.random.nextBytes(stream1);
         var10001.writeInt(1);
         var10001.writeInt(20);
         var10001.write(stream1);
         var10001.writeInt(var4);
         Cipher stream2 = this.makePBECipher("PBEWithSHAAndTwofish-CBC", 1, password, stream1, var4);
         CipherOutputStream password1;
         CipherOutputStream var10000 = password1 = new CipherOutputStream;
         var10000.<init>(var3, stream2);
         InfosecStore var10003 = this;
         SHA1Digest var5;
         var5 = new SHA1Digest.<init>();
         DigestOutputStream var10002 = new DigestOutputStream(password1, var5);
         var10003.saveStore(var10002);
         Digest var10 = var10002.getDigest();
         byte[] var6;
         var10.doFinal(var6 = new byte[var10.getDigestSize()], 0);
         var10000.write(var6);
         var10000.close();
      }
   }

   private class StoreEntry {
      int type;
      String alias;
      Object obj;
      Certificate[] certChain;
      Date date;

      StoreEntry(String alias, Certificate obj) {
         StoreEntry var10000 = this;
         StoreEntry var10001 = this;
         StoreEntry var10002 = this;
         StoreEntry var10003 = this;
         StoreEntry var10004 = this;
         super();
         Date var4;
         var4 = new Date.<init>();
         var10004.date = var4;
         var10003.type = 1;
         var10002.alias = alias;
         var10001.obj = obj;
         var10000.certChain = null;
      }

      StoreEntry(String alias, Key obj, Certificate[] certChain) {
         StoreEntry var10000 = this;
         StoreEntry var10001 = this;
         StoreEntry var10002 = this;
         StoreEntry var10003 = this;
         StoreEntry var10004 = this;
         super();
         Date var5;
         var5 = new Date.<init>();
         var10004.date = var5;
         var10003.type = 2;
         var10002.alias = alias;
         var10001.obj = obj;
         var10000.certChain = certChain;
      }

      StoreEntry(String alias, byte[] obj, Certificate[] certChain) {
         StoreEntry var10000 = this;
         StoreEntry var10001 = this;
         StoreEntry var10002 = this;
         StoreEntry var10003 = this;
         StoreEntry var10004 = this;
         super();
         Date var5;
         var5 = new Date.<init>();
         var10004.date = var5;
         var10003.type = 3;
         var10002.alias = alias;
         var10001.obj = obj;
         var10000.certChain = certChain;
      }

      StoreEntry(String alias, Key key, char[] password, Certificate[] certChain) {
         StoreEntry var10000 = this;
         super();
         this.date = new Date();
         this.type = 4;
         this.alias = alias;
         this.certChain = certChain;
         byte[] var7 = new byte[20];
         JDKKeyStore.this.random.setSeed(System.currentTimeMillis());
         JDKKeyStore.this.random.nextBytes(var7);
         int alias1 = (JDKKeyStore.this.random.nextInt() & 1023) + 1024;
         ByteArrayOutputStream certChain1;
         certChain1 = new ByteArrayOutputStream.<init>();
         DataOutputStream var6;
         DataOutputStream var10002 = var6 = new DataOutputStream;
         var6.<init>(certChain1);
         var6.writeInt(20);
         var6.write(var7);
         var10002.writeInt(alias1);
         Cipher var8 = JDKKeyStore.this.makePBECipher("PBEWithSHAAnd3-KeyTripleDES-CBC", 1, password, var7, alias1);
         CipherOutputStream alias2;
         alias2 = new CipherOutputStream.<init>(var6, var8);
         DataOutputStream var9;
         var10002 = var9 = new DataOutputStream;
         var9.<init>(alias2);
         JDKKeyStore.this.encodeKey(key, var9);
         var10002.close();
         var10000.obj = certChain1.toByteArray();
      }

      StoreEntry(String alias, Date date, int type, Object obj) {
         StoreEntry var10000 = this;
         StoreEntry var10001 = this;
         StoreEntry var10002 = this;
         StoreEntry var10003 = this;
         StoreEntry var10004 = this;
         super();
         Date var6;
         var6 = new Date.<init>();
         var10004.date = var6;
         var10003.alias = alias;
         var10002.date = date;
         var10001.type = type;
         var10000.obj = obj;
      }

      StoreEntry(String alias, Date date, int type, Object obj, Certificate[] certChain) {
         StoreEntry var10000 = this;
         StoreEntry var10001 = this;
         StoreEntry var10002 = this;
         StoreEntry var10003 = this;
         StoreEntry var10004 = this;
         StoreEntry var10005 = this;
         super();
         Date var7;
         var7 = new Date.<init>();
         var10005.date = var7;
         var10004.alias = alias;
         var10003.date = date;
         var10002.type = type;
         var10001.obj = obj;
         var10000.certChain = certChain;
      }

      int getType() {
         return this.type;
      }

      String getAlias() {
         return this.alias;
      }

      Object getObject() {
         return this.obj;
      }

      Object getObject(char[] password) {
         Object var2;
         if ((password == null || password.length == 0) && (var2 = this.obj) instanceof Key) {
            return var2;
         } else if (this.type == 4) {
            StoreEntry var10000 = this;
            StoreEntry var10001 = this;
            ByteArrayInputStream var37;
            var37 = new ByteArrayInputStream.<init>((byte[])this.obj);
            DataInputStream var10002 = new DataInputStream;
            DataInputStream var10003 = var10002;
            DataInputStream var3;
            DataInputStream var10004 = var3 = var10002;
            var10002.<init>(var37);

            boolean var46;
            byte[] var52;
            try {
               var52 = new byte[var10004.readInt()];
            } catch (Exception var34) {
               var46 = false;
               throw new UnrecoverableKeyException("no match");
            }

            byte[] var38 = var52;

            int var47;
            try {
               var10003.readFully(var52);
               var47 = var10002.readInt();
            } catch (Exception var33) {
               var46 = false;
               throw new UnrecoverableKeyException("no match");
            }

            int var4 = var47;

            Cipher var48;
            try {
               var48 = JDKKeyStore.this.makePBECipher("PBEWithSHAAnd3-KeyTripleDES-CBC", 2, password, var38, var4);
            } catch (Exception var32) {
               var46 = false;
               throw new UnrecoverableKeyException("no match");
            }

            Cipher var39 = var48;

            CipherInputStream var50;
            try {
               var50 = new CipherInputStream;
            } catch (Exception var31) {
               var46 = false;
               throw new UnrecoverableKeyException("no match");
            }

            CipherInputStream var41 = var50;

            try {
               var50.<init>(var3, var39);
            } catch (Exception var30) {
               var46 = false;
               throw new UnrecoverableKeyException("no match");
            }

            try {
               return JDKKeyStore.this.decodeKey(new DataInputStream(var41));
            } catch (Exception var29) {
               ByteArrayInputStream var49;
               try {
                  var10000 = this;
                  var10001 = this;
                  var49 = new ByteArrayInputStream;
               } catch (Exception var28) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               var37 = var49;

               try {
                  var49.<init>((byte[])this.obj);
                  var10002 = new DataInputStream;
               } catch (Exception var27) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               var10003 = var10002;
               var10004 = var10002;
               DataInputStream var10005 = var3 = var10002;

               try {
                  var10005.<init>(var37);
                  var52 = new byte[var10004.readInt()];
               } catch (Exception var26) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               var38 = var52;

               try {
                  var10003.readFully(var52);
                  var47 = var10002.readInt();
               } catch (Exception var25) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               var4 = var47;

               try {
                  var48 = JDKKeyStore.this.makePBECipher("BrokenPBEWithSHAAnd3-KeyTripleDES-CBC", 2, password, var38, var4);
               } catch (Exception var24) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               Cipher var5 = var48;

               try {
                  var50 = new CipherInputStream;
               } catch (Exception var23) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               CipherInputStream var6 = var50;

               try {
                  var50.<init>(var3, var5);
               } catch (Exception var22) {
                  var46 = false;
                  throw new UnrecoverableKeyException("no match");
               }

               Key var45;
               try {
                  var45 = JDKKeyStore.this.decodeKey(new DataInputStream(var6));
               } catch (Exception var21) {
                  try {
                     var10000 = this;
                     var10001 = this;
                     var49 = new ByteArrayInputStream;
                  } catch (Exception var20) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var37 = var49;

                  try {
                     var49.<init>((byte[])this.obj);
                     var10002 = new DataInputStream;
                  } catch (Exception var19) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var10003 = var10002;
                  var10004 = var10002;
                  var10005 = var3 = var10002;

                  try {
                     var10005.<init>(var37);
                     var52 = new byte[var10004.readInt()];
                  } catch (Exception var18) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var38 = var52;

                  try {
                     var10003.readFully(var52);
                     var47 = var10002.readInt();
                  } catch (Exception var17) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var4 = var47;

                  try {
                     var48 = JDKKeyStore.this.makePBECipher("OldPBEWithSHAAnd3-KeyTripleDES-CBC", 2, password, var38, var4);
                  } catch (Exception var16) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var5 = var48;

                  try {
                     var50 = new CipherInputStream;
                  } catch (Exception var15) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  var6 = var50;

                  try {
                     var50.<init>(var3, var5);
                     var45 = JDKKeyStore.this.decodeKey(new DataInputStream(var6));
                  } catch (Exception var14) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }
               }

               Key var40 = var45;
               if (var40 != null) {
                  ByteArrayOutputStream var54;
                  try {
                     var45 = var40;
                     var10001 = this;
                     var54 = new ByteArrayOutputStream;
                  } catch (Exception var13) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  ByteArrayOutputStream var43 = var54;

                  StoreEntry var51;
                  DataOutputStream var57;
                  try {
                     var51 = this;
                     var43.<init>();
                     var57 = new DataOutputStream;
                  } catch (Exception var12) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  DataOutputStream var44 = var57;

                  Cipher var53;
                  try {
                     var44.<init>(var43);
                     var44.writeInt(var38.length);
                     var44.write(var38);
                     var57.writeInt(var4);
                     var53 = JDKKeyStore.this.makePBECipher("PBEWithSHAAnd3-KeyTripleDES-CBC", 1, password, var38, var4);
                  } catch (Exception var11) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  Cipher password1 = var53;

                  CipherOutputStream var55;
                  try {
                     var55 = new CipherOutputStream;
                  } catch (Exception var10) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  CipherOutputStream var42 = var55;

                  DataOutputStream var56;
                  try {
                     var55.<init>(var44, password1);
                     var56 = new DataOutputStream;
                  } catch (Exception var9) {
                     var46 = false;
                     throw new UnrecoverableKeyException("no match");
                  }

                  DataOutputStream password2 = var56;

                  try {
                     password2.<init>(var42);
                     JDKKeyStore.this.encodeKey(var40, password2);
                     var56.close();
                     var10001.obj = var54.toByteArray();
                     return var45;
                  } catch (Exception var8) {
                     var46 = false;
                  }
               } else {
                  try {
                     throw new UnrecoverableKeyException("no match");
                  } catch (Exception var7) {
                     var46 = false;
                  }
               }
            }

            throw new UnrecoverableKeyException("no match");
         } else {
            throw new RuntimeException("forget something!");
         }
      }

      Certificate[] getCertificateChain() {
         return this.certChain;
      }

      Date getDate() {
         return this.date;
      }
   }
}
